class ButtonDb
{
  int x, y;
  int w, h;
  //Added id
  int id;
  color basecolor, highlightcolor;
  color currentcolor;
  boolean over = false;
  boolean pressed = false;   

  void pressed() {
    if(over && mousePressed) {
      pressed = true;
      //sets whichPressed to id.
      whichPressedD=id;
      changedD=true;
    } 
    else {
      pressed = false;
    }    
  }
  

  boolean overRect(int x, int y, int width, int height) {
    if (mouseX >= x && mouseX <= x+width && 
      mouseY >= y && mouseY <= y+height && lines[5].equals ("True")) {
      return true;
    } 
    else {
      return false;
    }
  }
}

class ImageButtonsDb extends ButtonDb 
{
  PImage base;
  PImage roll;
  PImage down;
  PImage selected;
  PImage currentimage;
  PImage not;
  //check out that there is an extra term for the id.
  ImageButtonsDb(int ix, int iy, int iw, int ih, PImage ibase, PImage iroll, PImage idown, PImage isel, PImage no, int number) 
  {
    x = ix;
    y = iy;
    w = iw;
    h = ih;

    //set the id to number. 
    id = number;
    base = ibase;
    roll = iroll;
    down = idown;
    selected = isel;
    not = no;
    currentimage = base;
  }

  void update() 
  {
    if(lines[5].equals ("True")){
    over();
    pressed();
    if(pressed) {
      currentimage = down;

    } 
    else if (over){
      currentimage = roll;
      if(whichPressedD==id){
        currentimage=selected;
      }

    } 
    else {
      currentimage = base;
      if(whichPressedD==id){
        currentimage=selected;
      }

    }
  }
  else{
    currentimage = not;
  }
  }
  
  void over() 
  {
    if( overRect(x+shelfMAypos, y+shelfMAypos, w+shelfMAypos, h+shelfMAypos) ) {
      over = true;
    } 
    else {
      over = false;
    }
  }

  void display() 
  {
    image(currentimage, x, y+shelfMAypos);
  }
}




