class LetterC{
  Point3D[] vertices = new Point3D[58];
  float w, h, d;

  // Constructors
  // default constructor
  LetterC(){
  }

  // constructor 2
  LetterC(float w, float h, float d){
    this.w = w;
    this.h = h;
    this.d = d;
    //front 
    vertices[0] = new Point3D(w/2,-h/2, d/16);
    vertices[1] = new Point3D(-w/2, -h/2, d/16);
    vertices[2] = new Point3D(-w/2, -(3*h)/10, d/16);
    vertices[3] = new Point3D(w/4,-(3*h)/10, d/16);
    vertices[4] = new Point3D(w/4, (3*h)/10, d/16);
    vertices[5] = new Point3D(-w/2, (3*h)/10, d/16);
    vertices[6] = new Point3D(-w/2, h/2, d/16); 
    vertices[7] = new Point3D(w/2, h/2, d/16);
    vertices[8] = new Point3D(w/2,-h/2, d/16);
    //left
    vertices[9] = new Point3D(w/2, -h/2, d/16);
    vertices[10] = new Point3D(w/2, -h/2, -d/16);
    vertices[11] = new Point3D(w/2, h/2 , -d/16);
    vertices[12] = new Point3D(w/2, h/2 , d/16);
    vertices[13] = new Point3D(w/2, -h/2, d/16);
    //right top
    vertices[14] = new Point3D(-w/2, -h/2, d/16);
    vertices[15] = new Point3D(-w/2, -h/2, -d/16);
    vertices[16] = new Point3D(-w/2, -(3*h)/10 , -d/16);
    vertices[17] = new Point3D(-w/2, -(3*h)/10 , d/16);
    vertices[18] = new Point3D(-w/2, -h/2, d/16);
    //right bottom
    vertices[19] = new Point3D(-w/2, h/2, d/16);
    vertices[20] = new Point3D(-w/2, h/2, -d/16);
    vertices[21] = new Point3D(-w/2, (3*h)/10 , -d/16);
    vertices[22] = new Point3D(-w/2, (3*h)/10 , d/16);
    vertices[23] = new Point3D(-w/2, h/2, d/16);
    //right middle
    vertices[24] = new Point3D(w/4,-(3*h)/10,d/16);
    vertices[25] = new Point3D(w/4,-(3*h)/10,-d/16);
    vertices[26] = new Point3D(w/4,(3*h)/10,-d/16);
    vertices[27] = new Point3D(w/4,(3*h)/10,d/16);
    vertices[28] = new Point3D(w/4,-(3*h)/10,d/16);
    //top
    vertices[29] = new Point3D(w/2,-h/2,d/16);
    vertices[30] = new Point3D(w/2,-h/2,-d/16);
    vertices[31] = new Point3D(-w/2, -h/2,-d/16);
    vertices[32] = new Point3D(-w/2, -h/2, d/16);
    vertices[33] = new Point3D(w/2,-h/2,d/16);
    //inner top
    vertices[34] = new Point3D(w/4,-(3*h)/10,d/16);
    vertices[35] = new Point3D(w/4,-(3*h)/10,-d/16);
    vertices[36] = new Point3D(-w/2,-(3*h)/10,-d/16);
    vertices[37] = new Point3D(-w/2, -(3*h)/10, d/16);
    vertices[38] = new Point3D(w/4,-(3*h)/10,d/16);
    //inner bottom
    vertices[39] = new Point3D(w/4,(3*h)/10,d/16);
    vertices[40] = new Point3D(w/4,(3*h)/10,-d/16);
    vertices[41] = new Point3D(-w/2,(3*h)/10,-d/16);
    vertices[42] = new Point3D(-w/2, (3*h)/10, d/16);
    vertices[43] = new Point3D(w/4,(3*h)/10,d/16);
    //bottom
    vertices[44] = new Point3D(w/2,h/2,d/16);
    vertices[45] = new Point3D(w/2,h/2,-d/16);
    vertices[46] = new Point3D(-w/2, h/2,-d/16);
    vertices[47] = new Point3D(-w/2, h/2, d/16);
    vertices[48] = new Point3D(w/2,h/2,d/16);
    //back
    vertices[49] = new Point3D(w/2,-h/2, -d/16);
    vertices[50] = new Point3D(-w/2, -h/2, -d/16);
    vertices[51] = new Point3D(-w/2, -(3*h)/10, -d/16);
    vertices[52] = new Point3D(w/4,-(3*h)/10, -d/16);
    vertices[53] = new Point3D(w/4, (3*h)/10, -d/16);
    vertices[54] = new Point3D(-w/2, (3*h)/10, -d/16);
    vertices[55] = new Point3D(-w/2, h/2, -d/16); 
    vertices[56] = new Point3D(w/2, h/2, -d/16);
    vertices[57] = new Point3D(w/2,-h/2, -d/16);

  }

  void create(color codonColor){

    fill(codonColor);

    beginShape();
    for (int i=0; i<8; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);

    beginShape();
    for (int i=9; i<13; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);

    beginShape();
    for (int i=14; i<18; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);

    beginShape();
    for (int i=19; i<23; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);

    beginShape();
    for (int i=24; i<28; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);

    beginShape();
    for (int i=29; i<33; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);

    beginShape();
    for (int i=34; i<38; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);
    beginShape();
    for (int i=39; i<43; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);

    beginShape();
    for (int i=44; i<48; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);

    beginShape();
    for (int i=49; i<57; i++){

      vertex(vertices[i].x, vertices[i].y, vertices[i].z);
    }
    endShape(CLOSE);
  }

}
